<?php

/*
  This controls addition of free link functionality, to make sure parsing
  happens in the correct order.

  Copyright 2003, 2004 John Rankin john.rankin@affinity.co.nz
*/

$AnyLetter = "[A-Za-z0-9]";
$PageNameSpace = "";
#$PageNameSpace = "_";
#$TitleWord = "[A-Z0-9]($AnyLetter*)(-($AnyLetter+))*";
#$PageTitlePattern = "($TitleWord)(_($TitleWord))*";
#$LinkPatterns[750]["\\b$GroupNamePattern([\\/.])$PageTitlePattern"] = 
#  $FmtWikiLink;
$TitlePattern = "[A-Z0-9]$AnyLetter*";
$PageTitlePattern = "$TitlePattern(-$AnyLetter+)*(~$TitlePattern)?";
$PageNamePattern = "($GroupNamePattern)([.\\/])($PageTitlePattern)";
$GroupFreeLinkPattern="{{(?>(?:($GroupNamePattern)([.\\/]))?([[:alnum:]]+(?:(?:[\\s_]*|[-~])[[:alnum:]]+)*)(?:\\|((?:(?:[\\s_]*|[-~])[[:alnum:]])*))?)}}((?:-?[[:alnum:]]+)*)";                                         $FreeLinkPattern="{{($AnyLetter+(?:(?:\s*|[-~])$AnyLetter+)*)(?:\\|((?:(?:\s*|[-~])$AnyLetter)*))?}}((-?$AnyLetter)*)";
$GroupLinkPattern = "(($GroupNamePattern)([.\\/]))?($FreeLinkPattern)";
$PageLinkPattern = 
  "($PageNamePattern)|($GroupLinkPattern)|($WikiWordPattern)";
#$UrlPathPattern="[^\\s<>[\\]\"\'()`]*[^\\s<>[\\]\"\'()`,.?]";
#$RecentChanges = array(
#      "Main.AllRecentChanges"=>'$Group.$Tlink',
#      '$Group.RecentChanges'=>'$Tlink');

function Wikify($word) {
  global $PageNameSpace;
  $linktext = preg_replace("/{{(.*)}}.*/","$1",str_replace("|","",$word));
  return preg_replace("/\s+/",$PageNameSpace,ucwords($linktext));
}

function QualifyLink($thisgroup,$link) {
  if (preg_match("/[.\\/]/",$link)) { return $link; }
  else { return "$thisgroup/$link"; }
}

?>